<template>
  <div class="app-container">

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-refresh"
          size="mini"
          @click="handleRefreshCache"
          v-hasPermi="['system:dict:remove']"
        >刷新缓存
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="typeList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center"/>

      <el-table-column label="字典类型" align="center" prop="key" :show-overflow-tooltip="true"/>

      <el-table-column label="备注" align="center" prop="remark" :show-overflow-tooltip="true"/>

      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['system:dict:edit']"
          >查看
          </el-button>

        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改参数配置对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-table v-loading="loading" :data="formList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center"/>

        <el-table-column label="名称" align="center" prop="label" :show-overflow-tooltip="true"/>

        <el-table-column label="编码" align="center" prop="value" :show-overflow-tooltip="true"/>

      </el-table>

      <div slot="footer" class="dialog-footer">

        <el-button @click="cancel">关 闭</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {listType, getType, delType, addType, updateType} from "@/api/system/dict/type";
import {listMetadata,refreshCache} from "@/api/xj/metadata";

export default {
  name: "Dict",
  dicts: ['sys_normal_disable'],
  data() {
    return {
      formList:[],
      // 遮罩层
      loading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 字典表格数据
      typeList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 日期范围
      dateRange: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        dictName: undefined,
        dictType: undefined,
        status: undefined
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        dictName: [
          {required: true, message: "字典名称不能为空", trigger: "blur"}
        ],
        dictType: [
          {required: true, message: "字典类型不能为空", trigger: "blur"}
        ]
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {

    transformToDeepCategorizedLabelValue(data) {
      const result = {};

      data.items.forEach(item => {
        Object.entries(item).forEach(([categoryKey, categoryValue]) => {
          if (!result[categoryKey]) {
            result[categoryKey] = {};
          }
          categoryValue.forEach(subCategory => {
            Object.entries(subCategory).forEach(([subCategoryKey, subCategoryValue]) => {
              if (!result[categoryKey][subCategoryKey]) {
                result[categoryKey][subCategoryKey] = [];
              }
              // 处理嵌套的对象，将其转换为 label 和 value
              if (typeof subCategoryValue === 'object') {
                Object.entries(subCategoryValue).forEach(([key, value]) => {
                  result[categoryKey][subCategoryKey].push({
                    label: value,
                    value: key
                  });
                });
              } else {
                result[categoryKey][subCategoryKey].push({
                  label: subCategoryValue,
                  value: subCategoryKey
                });
              }
            });
          });
        });
      });

      return result;
    },
    transformToDeepCategorizedListLabelValue(data) {
      const temp = {};
      const result = [];

      data.items.forEach(item => {
        Object.entries(item).forEach(([categoryKey, categoryValue]) => {

          categoryValue.forEach(subCategory => {
            Object.entries(subCategory).forEach(([subCategoryKey, subCategoryValue]) => {

              // 处理嵌套的对象，将其转换为 label 和 value
              if (typeof subCategoryValue === 'object') {
                if (!temp[categoryKey + ":" + subCategoryKey]) {
                  temp[categoryKey + ":" + subCategoryKey] = [];
                }

                Object.entries(subCategoryValue).forEach(([key, value]) => {
                  temp[categoryKey + ":" + subCategoryKey].push({
                    label: value,
                    value: key
                  });
                });
              } else {
                temp[categoryKey + ":" + subCategoryKey].push({
                  label: subCategoryValue,
                  value: subCategoryKey
                });
              }
            });
          });
        });
      });

      Object.entries(temp).forEach(([categoryKey, categoryValue]) => {
        result.push({key: categoryKey, value: categoryValue});
      })

      this.total = result.length;

      if (this.queryParams.pageNum *this.queryParams.pageSize > result.length) {
        return result.slice((this.queryParams.pageNum -1)*this.queryParams.pageSize, result.length);
      }else{
        return result.slice((this.queryParams.pageNum -1)*this.queryParams.pageSize,this.queryParams.pageSize*this.queryParams.pageNum);
      }

      return result;
    },

    getTypeInfo() {


    },
    /** 查询字典类型列表 */
    getList() {
      this.loading = true;


      listMetadata().then(response => {

        this.typeList = this.transformToDeepCategorizedListLabelValue(JSON.parse(response.data))
        // console.log(this.typeList)
        this.loading = false;

      })
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        dictId: undefined,
        dictName: undefined,
        dictType: undefined,
        status: "0",
        remark: undefined
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRange = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加字典类型";
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.dictId)
      this.single = selection.length != 1
      this.multiple = !selection.length
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
 /*     this.reset();
      const dictId = row.dictId || this.ids
      getType(dictId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改字典类型";
      });*/

      this.formList = row.value;
      this.open = true;
    },
    /** 提交按钮 */
    submitForm: function () {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.dictId != undefined) {
            updateType(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addType(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const dictIds = row.dictId || this.ids;
      this.$modal.confirm('是否确认删除字典编号为"' + dictIds + '"的数据项？').then(function () {
        return delType(dictIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {
      });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('system/dict/type/export', {
        ...this.queryParams
      }, `type_${new Date().getTime()}.xlsx`)
    },
    /** 刷新缓存按钮操作 */
    handleRefreshCache() {
      refreshCache().then(() => {
        this.$modal.msgSuccess("刷新成功");
        this.$store.dispatch('dict/cleanDict');
      });
    }
  }
};
</script>
